open Parser;;

(* type arith *)
type arith = Num of int
           | Add of arith * arith
           | Mul of arith * arith

(* parse expression *)
(* e : unit -> (arith, char) t*)
let rec e() = t() >>= e'
and e' term = (
  char '+' >>= fun _ ->
  t()      >>=
  e'       >>= fun t2 ->
  return(Add(term,t2))
) <|> return term
and t() = f() >>= t'
and t' factor = (
  char '*' >>= fun _ ->
  f()      >>=
  t'       >>= fun f2 ->
  return(Mul(factor,f2))
) <|> return factor
and f() = (
  char '(' >>= fun _ ->
  e()      >>= fun e1 ->
  char ')' >>
  return e1
) <|> n
and n = many1 digit >>= fun r -> 
 return (Num (int_of_string (Strng.to_string r)))

(* *)
